﻿using System.Collections;

using DevExpress.XtraPivotGrid.Data;

namespace TestProject
{
    /// <summary>
    /// 필터 항목 비교자
    /// </summary>
    public class FilterItemComparer : IComparer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 비교하기 - IComparer.Compare(x, y)

        /// <summary>
        /// 비교하기
        /// </summary>
        /// <param name="x">X</param>
        /// <param name="y">Y</param>
        /// <returns>비교 결과</returns>
        int IComparer.Compare(object x, object y)
        {
            if(!(x is PivotGridFilterItem) || !(y is PivotGridFilterItem))
            {
                return 0;
            }

            PivotGridFilterItem item1 = (PivotGridFilterItem)x;
            PivotGridFilterItem item2 = (PivotGridFilterItem)y;

            if(item1.ToString().Length == item2.ToString().Length)
            {
                return 0;
            }

            if(item1.ToString().Length > item2.ToString().Length)
            {
                return 1;
            }

            return -1;
        }

        #endregion
    }
}