using System;
using System.Collections;

using DevExpress.XtraEditors;
using DevExpress.XtraPivotGrid;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.excelDataSource.FileName = "SalesPerson.xlsx";

            this.excelDataSource.Fill();

            this.alphabeticallyRadioButton.CheckedChanged += alphabeticallyRadioButton_CheckedChanged;
            this.pivotGridControl.CustomFilterPopupItems  += pivotGridControl_CustomFilterPopupItems;

            this.pivotGridControl.DataSource = this.excelDataSource;

            this.pivotGridControl.BestFit();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Alphabetically  ư üũ  óϱ - alphabeticallyRadioButton_CheckedChanged(sender, e)

        /// <summary>
        /// Alphabetically  ư üũ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void alphabeticallyRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.productNameField.ShowFilterPopup();
        }

        #endregion
        #region ǹ ׸ Ʈ  ˾ ׸ Ŀ ϱ - pivotGridControl_CustomFilterPopupItems(sender, e)

        /// <summary>
        /// ǹ ׸ Ʈ  ˾ ׸ Ŀ ϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pivotGridControl_CustomFilterPopupItems(object sender, PivotCustomFilterPopupItemsEventArgs e)
        {
            if(this.byCaptionLengthRadioButton.Checked)
            {
                ArrayList.Adapter((IList)e.Items).Sort(new FilterItemComparer());
            }
        }

        #endregion
    }
}